﻿namespace SalesReporting.Entity {
    using System;
    using System.Collections.Generic;

    public class SalesOrder {
        public IList<SalesOrderDetail> SalesOrderDetails { get; set; }
        public Int32 SalesOrderId { get; set; }

        public SalesOrder() {
            this.SalesOrderDetails = new List<SalesOrderDetail>();
        }
    }

    class SalesOrders
    {
        public static IEnumerable<SalesOrderDetail> GetOrderDetails()
        {
            return new [] {
                        new SalesOrderDetail { Name="1st", OrderQty=3, UnitPrice=1045.5 },
                        new SalesOrderDetail { Name="2nd", OrderQty=5, UnitPrice=100.0 },
                        new SalesOrderDetail { Name="3rd", OrderQty=2, UnitPrice=2345.8 },
                        new SalesOrderDetail { Name="4th", OrderQty=1, UnitPrice=11.67 },
                    };
        }


        public static IEnumerable<SalesOrder> GetOrders()
        {
            return new[] {
                new SalesOrder {
                    SalesOrderId = 1,
                    SalesOrderDetails = new [] {
                        new SalesOrderDetail { Name="1st", OrderQty=3, UnitPrice=1045.5 },
                        new SalesOrderDetail { Name="2nd", OrderQty=5, UnitPrice=100.0 },
                        new SalesOrderDetail { Name="3rd", OrderQty=2, UnitPrice=2345.8 },
                        new SalesOrderDetail { Name="4th", OrderQty=1, UnitPrice=11.67 },
                    }
                },

                new SalesOrder {
                    SalesOrderId = 2,
                    SalesOrderDetails = new [] {
                        new SalesOrderDetail { Name="5th", OrderQty=1, UnitPrice=200.0 },
                        new SalesOrderDetail { Name="6th", OrderQty=8, UnitPrice=100.0 },
                        new SalesOrderDetail { Name="7th", OrderQty=9, UnitPrice=188.55 },
                        new SalesOrderDetail { Name="8th", OrderQty=11, UnitPrice=1345.0 },
                    }
                },

                new SalesOrder {
                    SalesOrderId = 3,
                    SalesOrderDetails = new [] {
                        new SalesOrderDetail { Name="9th", OrderQty=23, UnitPrice=34.0 },
                        new SalesOrderDetail { Name="10th", OrderQty=3, UnitPrice=180.0 },
                        new SalesOrderDetail { Name="11th", OrderQty=6, UnitPrice=45.90 },
                        new SalesOrderDetail { Name="12th", OrderQty=15, UnitPrice=90.55 },
                    }
                },

                new SalesOrder {
                    SalesOrderId = 4,
                    SalesOrderDetails = new [] {
                        new SalesOrderDetail { Name="13th", OrderQty=25, UnitPrice=1.0 },
                        new SalesOrderDetail { Name="14th", OrderQty=3, UnitPrice=1.0 },
                        new SalesOrderDetail { Name="15th", OrderQty=1, UnitPrice=4.0 },
                        new SalesOrderDetail { Name="16th", OrderQty=1, UnitPrice=9.0 },
                    }
                },
            };
        }
    }
}